{{
From Parallax Inc. Propeller Education Kit - Counters & Circuits Lab   
CalibrateMetalDetector.spin
}}

CON
   
  _clkmode = xtal1 + pll16x            ' Set up 80 MHz internal clock
  _xinfreq = 5_000_000


OBJ                                   
   
  Debug   : "FullDuplexSerialPlus"
  frq     : "SquareWave"


PUB Init | count, f, fstart, fstep, c

  'Start FullDuplexSerialPlus
  Debug.start(31, 30, 0, 57600)
  waitcnt(clkfreq*2 + cnt)

  'Configure ctra module for 50 MHz square wave
  ctra[30..26] := %00010
  ctra[25..23] := %110            
  ctra[8..0] := 15                    
  frq.Freq(0, 15, 50_000_000)                         
  dira[15]~~
  
  'Configure ctrb module for negative edge counting
  ctrb[30..26] := %01000               
  ctrb[8..0] := 13
  frqb := 1

  c := "S"

  repeat' until c == "Q" or c == "q"

    case c
      "S", "s":
        Debug.Str(String(10, 13, "Starting Frequency: "))
        f := Debug.GetDec
        Debug.Str(String(10, 13, "Step size: "))
        fstep := Debug.GetDec
        Debug.Str(String(10, 13))
         
    case c
      "S", "s", 13, 10, "M", "m":
        repeat 22
          frq.Freq(0, 15, f)   
          count := phsb
          waitcnt(clkfreq/10000 + cnt)                      
          count := phsb - count
          Debug.Str(String(10, 13, "Freq = "))
          Debug.Dec(f)
          Debug.Str(String("  count = "))
          Debug.Dec(count)
          waitcnt(clkfreq/20 + cnt)
          f += fstep
         
        Debug.str(String(10,13,"Enter->more, Q->Quit, S->Start over, R->repeat: "))
        c := Debug.rx
        Debug.str(String(10, 13))

      "R", "r":
        f -= (22 * fstep)
        c := "m"
     
      "Q", "q": quit

  Debug.str(String(10, 13, "Bye!"))      

